﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using UpDownCounterClass; // Must reference the UpDownCounter class

namespace Form_Application
{
    public partial class Form1 : Form
    {        
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        { }

        private void bCountUp_Click(object sender, EventArgs e)
        {
            tbDebug.AppendText("Counting Up\r\n");
            UpDownCounter upCount = new UpDownCounter();
            upCount.OnCallBack += updateStatus; // Register to the onCallBack event and call updateStatus method when the event is fired
            upCount.countUp((int)intUpperLimit.Value, (int)intLowerLimit.Value, (int)intDelay.Value);
            upCount.OnCallBack -= updateStatus; // Unregister for the event
        }

        private void bCountDown_Click(object sender, EventArgs e)
        {
            tbDebug.AppendText("Counting Down\r\n");
            UpDownCounter downCount = new UpDownCounter();
            downCount.OnCallBack += updateStatus; // Register to the onCallBack event and call updateStatus method when the event is fired
            downCount.countDown((int)intUpperLimit.Value, (int)intLowerLimit.Value, (int)intDelay.Value);
            downCount.OnCallBack -= updateStatus; // Unregister for the event
        }

        // Private method which is called each time the onCallBack event is fired
        private void updateStatus(int status)
        {
            tbDebug.AppendText(status.ToString() + "\r\n");
        }
    }
}
