﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Threading;

namespace UpDownCounterClass // Going to referenced in the LabVIEW constructor
{
    public delegate void CountStatus(int countValue); // Declare the delegate

    public class UpDownCounter
    {
        // Constructor
        public UpDownCounter()
        { }

        //Destructor
        ~UpDownCounter()
        { }

        public event CountStatus OnCallBack; // Create callback event and define a name

        public bool countUp(int upper, int lower, int sleep)
        {
            for(int i = lower; i <= upper; i++)
            {
                OnCallBack(i); // Generate the event
                Thread.Sleep(sleep);
            }
            return true;
        }

        public bool countDown(int upper, int lower, int sleep)
        {
            for (int i = upper; i >= lower; i--)
            {
                OnCallBack(i); //Generate the event
                Thread.Sleep(sleep);
            }
            return true;
        }
    }
}
